<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>ConnectionBean.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server</a> &gt; <span class="el_source">ConnectionBean.java</span></div><h1>ConnectionBean.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server;

import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.util.Arrays;
import java.util.Date;

import javax.management.ObjectName;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.jmx.MBeanRegistry;
import org.apache.zookeeper.jmx.ZKMBeanInfo;

/**
 * Implementation of connection MBean interface.
 */
public class ConnectionBean implements ConnectionMXBean, ZKMBeanInfo {
<span class="fc" id="L38">    private static final Logger LOG = LoggerFactory.getLogger(ConnectionBean.class);</span>

    private final ServerCnxn connection;
    private final Stats stats;

    private final ZooKeeperServer zk;
    
    private final String remoteIP;
    private final long sessionId;

<span class="fc" id="L48">    public ConnectionBean(ServerCnxn connection,ZooKeeperServer zk){</span>
<span class="fc" id="L49">        this.connection = connection;</span>
<span class="fc" id="L50">        this.stats = connection;</span>
<span class="fc" id="L51">        this.zk = zk;</span>
        
<span class="fc" id="L53">        InetSocketAddress sockAddr = connection.getRemoteSocketAddress();</span>
<span class="pc bpc" id="L54" title="1 of 2 branches missed.">        if (sockAddr == null) {</span>
<span class="nc" id="L55">            remoteIP = &quot;Unknown&quot;;</span>
        } else {
<span class="fc" id="L57">            InetAddress addr = sockAddr.getAddress();</span>
<span class="fc bfc" id="L58" title="All 2 branches covered.">            if (addr instanceof Inet6Address) {</span>
<span class="fc" id="L59">                remoteIP = ObjectName.quote(addr.getHostAddress());</span>
            } else {
<span class="fc" id="L61">                remoteIP = addr.getHostAddress();</span>
            }
        }
<span class="fc" id="L64">        sessionId = connection.getSessionId();</span>
<span class="fc" id="L65">    }</span>
    
    public String getSessionId() {
<span class="fc" id="L68">        return &quot;0x&quot; + Long.toHexString(sessionId);</span>
    }

    public String getSourceIP() {
<span class="nc" id="L72">        InetSocketAddress sockAddr = connection.getRemoteSocketAddress();</span>
<span class="nc bnc" id="L73" title="All 2 branches missed.">        if (sockAddr == null) {</span>
<span class="nc" id="L74">            return null;</span>
        }
<span class="nc" id="L76">        return sockAddr.getAddress().getHostAddress()</span>
<span class="nc" id="L77">            + &quot;:&quot; + sockAddr.getPort();</span>
    }

    public String getName() {
<span class="fc" id="L81">        return MBeanRegistry.getInstance().makeFullPath(&quot;Connections&quot;, remoteIP,</span>
<span class="fc" id="L82">                getSessionId());</span>
    }
    
    public boolean isHidden() {
<span class="fc" id="L86">        return false;</span>
    }
    
    public String[] getEphemeralNodes() {
<span class="nc bnc" id="L90" title="All 2 branches missed.">        if(zk.getZKDatabase()  !=null){</span>
<span class="nc" id="L91">            String[] res = zk.getZKDatabase().getEphemerals(sessionId)</span>
<span class="nc" id="L92">                .toArray(new String[0]);</span>
<span class="nc" id="L93">            Arrays.sort(res);</span>
<span class="nc" id="L94">            return res;</span>
        }
<span class="nc" id="L96">        return null;</span>
    }
    
    public String getStartedTime() {
<span class="nc" id="L100">        return stats.getEstablished().toString();</span>
    }
    
    public void terminateSession() {
        try {
<span class="nc" id="L105">            zk.closeSession(sessionId);</span>
<span class="nc" id="L106">        } catch (Exception e) {</span>
<span class="nc" id="L107">            LOG.warn(&quot;Unable to closeSession() for session: 0x&quot; </span>
<span class="nc" id="L108">                    + getSessionId(), e);</span>
<span class="nc" id="L109">        }</span>
<span class="nc" id="L110">    }</span>
    
    public void terminateConnection() {
<span class="nc" id="L113">        connection.sendCloseSession();</span>
<span class="nc" id="L114">    }</span>

    public void resetCounters() {
<span class="nc" id="L117">        stats.resetStats();</span>
<span class="nc" id="L118">    }</span>

    @Override
    public String toString() {
<span class="nc" id="L122">        return &quot;ConnectionBean{ClientIP=&quot; + ObjectName.quote(getSourceIP())</span>
<span class="nc" id="L123">            + &quot;,SessionId=0x&quot; + getSessionId() + &quot;}&quot;;</span>
    }
    
    public long getOutstandingRequests() {
<span class="nc" id="L127">        return stats.getOutstandingRequests();</span>
    }
    
    public long getPacketsReceived() {
<span class="nc" id="L131">        return stats.getPacketsReceived();</span>
    }
    
    public long getPacketsSent() {
<span class="nc" id="L135">        return stats.getPacketsSent();</span>
    }
    
    public int getSessionTimeout() {
<span class="nc" id="L139">        return connection.getSessionTimeout();</span>
    }

    public long getMinLatency() {
<span class="nc" id="L143">        return stats.getMinLatency();</span>
    }

    public long getAvgLatency() {
<span class="nc" id="L147">        return stats.getAvgLatency();</span>
    }

    public long getMaxLatency() {
<span class="nc" id="L151">        return stats.getMaxLatency();</span>
    }
    
    public String getLastOperation() {
<span class="nc" id="L155">        return stats.getLastOperation();</span>
    }

    public String getLastCxid() {
<span class="nc" id="L159">        return &quot;0x&quot; + Long.toHexString(stats.getLastCxid());</span>
    }

    public String getLastZxid() {
<span class="nc" id="L163">        return &quot;0x&quot; + Long.toHexString(stats.getLastZxid());</span>
    }

    public String getLastResponseTime() {
<span class="nc" id="L167">        return new Date(stats.getLastResponseTime()).toString();</span>
    }

    public long getLastLatency() {
<span class="nc" id="L171">        return stats.getLastLatency();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>